#ifndef __SSLTYPES_H
#define __SSLTYPES_H

#include <openssl/ssl.h>

#ifdef __cplusplus
extern "C" {
#endif


#define JNI_ERR_WRONG_INPUT				3000
#define JNI_ERR_OUTOF_MEMORY			3001
#define JNI_ERR_READ_CONF				3002
#define JNI_ERR_NO_FIELD				3003
#define JNI_ERR_FAILTO_SET_CIPHER		3004
#define JNI_ERR_LOAD_VERIFY_LOC			3005	
#define JNI_ERR_FAILTO_CREATE_CRL_STORE	3006
#define JNI_FAILTO_READ_CERT			3007
#define JNI_FAILTO_READ_PRIVATEKEY		3008

struct jni_context {
	SSL_CTX *ssl_ctx;
	char *SSLSessionCache;
	long SSLSessionCacheTimeout;
	char *SSLEngine;
    char *SSLCipherSuite;
	char *SSLCACertificatePath;
	/*   Ǹ ڵ CRL  ϴ  Ѵ. */
	char *SSLCARevocationPath;
	char *SSLCertificateFile;
	char *SSLCertificateKeyFile;
	char *SSLCertificateKeyPasswd;
	int SSLVerify;
    int SSLVerifyDepth;
	int SSLProtocol;

	X509_STORE *RevocationStore;
	char *DebugOption;
	char *LogPath;
	char *LogFile;
	char *LogOption;
};

struct ssl_context {
	SSL *ctx;
	BIO *mbio;
	BIO *ebio;
};

int jni_verify(int ok, X509_STORE_CTX *ctx);


#ifdef __cplusplus
}
#endif

#endif /* __SSLTYPES_H */



