/* blssl/brm_ssl.h */
/* ====================================================================
 * Copyright (C) 2002 Jung-Ho Cha (hinunbi@users.kldp.net).  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the "Barunmo" nor the names of its 
 *    contributors may not be used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 *    For written permission, please contact hinunbi@users.kldp.net.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
 * THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes software developed by the OpenSSL Project
 * for use in the OpenSSL Toolkit. (http://www.openssl.org/)
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */


#ifndef __BRM_SSL_H
#define __BRM_SSL_H

#include <openssl/bio.h>
#include <openssl/ssl.h>
#include "blssl.h"

#ifdef JNI_TRUE
#define BRM_FALSE	JNI_FALSE
#define BRM_TRUE	JNI_TRUE
#else
#define BRM_FALSE	0
#define BTM_TRUE	1
#endif

#define BRM_BUF_SIZE	4096

#ifdef __cplusplus
extern "C" {
#endif

int cert_verify_cb(int ok, X509_STORE_CTX *ctx);
int crl_lookup(X509_STORE *store, X509_NAME *name, X509_OBJECT *obj);
long bio_dump_rcb(BIO *bio, int cmd, const char *argp, int argi, long argl, long ret);
long bio_dump_wcb(BIO *bio, int cmd, const char *argp, int argi, long argl, long ret);
int handshake_finished(BRM_SSL *bssl);
void print_connect_info(BRM_SSL *jssl);
int SSL_CTX_use_PrivateKey_file_ex(SSL_CTX *ctx, const char *file,  int type, char *passwd);
int chk_protocol_option(char *line, char *which, int wv, int *proto);

extern int app_index;
extern char *app_index_name;

#ifdef __cplusplus
}
#endif

#endif /* __BRM_SSL_H */



