/* ====================================================================
 * Copyright (C) 2002 Jung-Ho Cha (hinunbi@users.kldp.net).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the "Barunmo" nor the names of its
 *    contributors may not be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *    For written permission, please contact hinunbi@users.kldp.net.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes software developed by the OpenSSL Project
 * for use in the OpenSSL Toolkit. (http://www.openssl.org/)
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

package com.brm.net.ssl;

/**
 * <p>Title: Barunmo Java SSL Socket Class</p>
 * <p>Description: SSL Socket Class by using OpenSSL</p>
 * <p>Copyright: Copyright (c) 2002  Jung-Ho Cha</p>
 * <p>Company: Barunmo</p>
 * @author Jung-Ho Cha
 * @version 1.0.0
 */

import com.brm.net.ssl.SSLGlobal;

public class SSLConf
{
	private native void nativeGetSSLConf(String confFile);
	/**
	 * SSL Handshake   Timeout Ѵ. ( : )
	 */
	public int SSLHandShakeTimeout;
	/**
	 *  Ÿ־ƿ Ѵ.
	 */
	public int SSLSessionCacheTimeout;

	// ܺ  ĳ Ѵ. ʿϸ .
	//  ĳ  ޸  Ѵ.
	// SSLSessionCache dbm:/usr/local/apache/logs/ssl_gcache_data
	// public String SSLSessionCache;

	// ȣ ϵ ӱ  . ʿϸ .
	// SSLEngine on
	// public String SSLEngine;
	/**
	 * CA   丮 ġ
	 */
	public String SSLCACertificatePath;

	// CA   .     ϱ.
	// public String SSLCACertificateFile;
	/**
	 * CRL  丮 ġ.  ׽Ʈ  ʾ,
	 * ʿϴٸ .
	 */
	public String SSLCARevocationPath;
	/**
	 * CRL ڵ  
	 * CRL й  ִ ̰  ɼ  ִٸ CRL ڵ .
	 * ׷ CRL  κ    ʾ.
	 *
	 * ֳϸ   ϴ CRL й    
	 * ʰ CRL  ȿϴ ο CRLй    ؾ
	 * ϴ  CRL      CRL   ȿ ݵ
	 * ߿  ϴ  ƴ϶ ϹǷ.   ߿ϰ...
	 * ʿϴٸ .
	 *  Ʒ   ϴ CRL  ldap  ּ <br>
	 * kisa : dirsys.rootca.or.kr:389 <br>
	 * yessign : 203.233.91.35:389
	 */
	public String SSLCARevocationAutoUpdate;
	/**
	 * SSL Ʈ  stderr  
	 *  : On,  : Off
	 */
	public String SSLMessageTrace;

	/**
	 *   
	 * mod_ssl  ϹǷ mod_ssl  Ѵ.
	 *   Ǵ  ɼǸ Ѵ. <br>
	 * <br>
	 * none - PEER    ʴ´.<br>
	 * optional<br>
	 * require - PEER  Ѵ.<br>
	 *require_no_ca
	 */
	public String SSLVerify;

	/**
	 *    . SSLVerify ɼǰ Բ ؾ ǹ̸ 
	 *   SSLVerifyDepth = 0 ̰ SSLVerify = require ̸ Ƹ 
	 *     (?). <br><br>
	 * 0 :   <br>
	 * 1 : ߱  <br>
	 * 2 : ߱ڿ  ߱  <br>
	 * ...
	 */
	public int SSLVerifyDepth;
	/**
	 * ڽ   
	 */
	public String SSLCertificateFile;
	/**
	 * ڽ Ű  
	 */
	public String SSLCertificateKeyFile;

	/**
	 *    
	 *  κ  mod_ssl . mod_ssl  OpenSSL .
	 */
	public String SSLProtocol;
	/**
	 *  ȣ  
	 *  κ  mod_ssl . mod_ssl  OpenSSL .
	 */
	public String SSLCipherSuite;


  public SSLConf()
  {
	  defaultConf();
  }

  /**
   * conf  д SSLConf Ʈ 
   * ̸    ϴ   ڸ Ѵ.
   *
   * @param confFile  
   */
  public SSLConf(String confFile)
    {
		nativeGetSSLConf(confFile);
    }
	/**
	 *    SSLConf Ʈ .
	 * Ŭ̾Ʈ        Ѵ.
	 *   ϰ Ŭ̾Ʈ   Ѵ.
	 */
	public void defaultConf()
	{
		SSLHandShakeTimeout = 30;
	    SSLSessionCacheTimeout = 0;
		SSLCACertificatePath = null;
		SSLCARevocationPath = null;
		SSLCARevocationAutoUpdate = "Off";
		SSLVerify = "none";
		SSLVerifyDepth = 0;
		SSLCertificateFile = null;
		SSLCertificateKeyFile = null;
		SSLProtocol = "SSLv3";
		SSLCipherSuite = "DES-CBC-SHA";
		SSLMessageTrace = "Off";
	}

	public String toString()
	{
		String ret;

		ret = "SSLConf {\n\t" +
		      "SSLHandShakeTimeout = [" + SSLHandShakeTimeout + " sec]\n\t" +
			   // "SSLSessionCache = [" + SSLSessionCache + "]\n\t" +
			  "SSLSessionCacheTimeout = [" + Integer.toString(SSLSessionCacheTimeout) + " sec]\n\t" +
			  "SSLCACertificatePath = [" + SSLCACertificatePath + "]\n\t" +
			  "SSLCARevocationPath = [" + SSLCARevocationPath + "]\n\t" +
			  "SSLCARevocationAutoUpdate = [" + SSLCARevocationAutoUpdate + "]\n\t" +
			  "SSLVerify = [" + SSLVerify + "]\n\t" +
			  "SSLVerifyDepth = [" + Integer.toString(SSLVerifyDepth) + "]\n\t" +
			  "SSLCertificateFile = [" + SSLCertificateFile + "]\n\t" +
			  "SSLCertificateKeyFile = [" + SSLCertificateKeyFile + "]\n\t" +
			  "SSLProtocol = [" + SSLProtocol + "]\n\t" +
			  "SSLCipherSuite = [" + SSLCipherSuite + "]\n\t" +
			  // "SSLEngine = [" + SSLEngine + "]\n\t" +
              "SSLMessageTrace = [" + SSLMessageTrace + "]\n\t" +
		      "}";
		return ret;
    }

	// Load the native routines.
	static
	{
		try
		{
			System.loadLibrary("blssl");
		}
		catch(Exception e)
		{
			System.out.println("blssl library not found");
			e.printStackTrace();
		}
	}
}